﻿using LogService;
using LogService.Impl;
using Ninject.Modules;
using UserService;
using UserService.Impl;

namespace MVCApp.Helper
{
    internal class ServiceModule : NinjectModule
    {
        public override void Load()
        {
            Bind<ILogService>().To<TxtLogService>();
            Bind<IUserService>().To<UserInfoService>();
        }
    }
}