﻿//using System;
//using System.IO;
//using System.Web;
//using Ninject;
//using Ninject.Activation.Caching;
//using Ninject.Infrastructure.Disposal;
//using NinjectApp.Weapon;
//using NUnit.Framework;

//namespace NinjectApp.Test
//{
//    [TestFixture]
//    public class RequestScopeContext
//    {
//        protected readonly StandardKernel kernel;

//        public RequestScopeContext()
//        {
//            var settings = new NinjectSettings { CachePruningInterval = TimeSpan.MaxValue };
//            kernel = new StandardKernel(settings);
//        }

//        public void BeginNewFakeWebRequest()
//        {
//            HttpContext.Current = GetFakeHttpContext();
//        }

//        public HttpContext GetFakeHttpContext()
//        {
//            var request = new HttpRequest("index.html", "http://example.org/index.html", String.Empty);
//            var response = new HttpResponse(new StringWriter());
//            return new HttpContext(request, response);
//        }
//    }

//    [TestFixture]
//    public class WhenServiceIsBoundWithRequestScope : RequestScopeContext
//    {
//        [Test]
//        public void InstancesAreReusedWithinSameHttpContext()
//        {
//            kernel.Bind<IWeapon>().To<Sword>().InRequestScope();

//            BeginNewFakeWebRequest();

//            var weapon1 = kernel.Get<IWeapon>();
//            var weapon2 = kernel.Get<IWeapon>();

//            Assert.AreSame(weapon1, weapon2);

//            //Assert.AreEqual(weapon1, weapon2);

//            BeginNewFakeWebRequest();

//            GC.Collect();
//            GC.WaitForPendingFinalizers();

//            var weapon3 = kernel.Get<IWeapon>();

//            Assert.AreSame(weapon3, weapon1);
//            Assert.AreSame(weapon3, weapon2);
//        }

//        [Test]
//        public void InstancesAreDisposedWhenRequestEndsAndCacheIsPruned()
//        {
//            kernel.Bind<INotifyWhenDisposed>().To<NotifiesWhenDisposed>().InRequestScope();
//            var cache = kernel.Components.Get<ICache>();

//            BeginNewFakeWebRequest();

//            var instance = kernel.Get<INotifyWhenDisposed>();

//            Assert.IsNull(instance);
//            //Assert.IsInstanceOf<NotifiesWhenDisposed>(instance);

//            BeginNewFakeWebRequest();

//            GC.Collect();
//            GC.WaitForPendingFinalizers();

//            cache.Prune();

//            Assert.IsTrue(instance.IsDisposed);
//        }

//        [Test]
//        public void InstancesAreDisposedViaOnePerRequestModule()
//        {
//            kernel.Bind<INotifyWhenDisposed>().To<NotifiesWhenDisposed>().InRequestScope();

//            BeginNewFakeWebRequest();

//            var instance = kernel.Get<INotifyWhenDisposed>();

//            Assert.IsNull(instance);
//            //Assert.IsInstanceOf<NotifiesWhenDisposed>(instance);

//            OnePerRequestModule.DeactivateInstancesForCurrentHttpRequest();

//            Assert.IsTrue(instance.IsDisposed);
//        }
//    }
//}
